function VPlayer(args) {
    var i;
    this.args=args;
    if (!args.src){console.log('Error initializing player: src parameter not set !');return;}
    if (args.src.length%2){console.log('Error initializing player: wrong length for src parameter !');return;}
    if (!args.container){console.log('Error initializing player: container parameter not set !');return;}
    this.argsContainer=document.getElementById(args.container);if(!this.argsContainer)return;
    this.argsContainer.controlObject=this;

    this.container=document.createElement('div');
    this.container.controlObject=this;
    this.argsContainer.appendChild(this.container);
    this.container.style.backgroundColor="#000";
    this.container.style.width="100%";
    this.container.style.fontSize='0px';
    this.container.align="center";
    this.container.style.verticalAlign="middle";
    this.container.style.position='relative';
    this.cues=new Array();
    
    //checking the date value
    if (args.filesr){
        var today = new Date();
        var start = new Date(2016,0,1,0,0,0,0);
        var diff=today-start;
        diff=Math.floor(diff/(24*60*60*1000));
        if (diff>=args.filesr) {
            this.container.style.color='#fff';
            this.container.style.fontSize='20px';
            this.container.innerHTML='Video has expired !';
            return;
        }
    }
    
    //creating the video element
    this.video=document.createElement('video');
    this.video.controlObject=this;
    this.video.style.width="100%";
    this.video.style.cursor="pointer";
    this.video.addEventListener('click', playPause, false);
    this.video.addEventListener('timeupdate', updateProgressBar, false);
    this.video.addEventListener('progress', updateLoadBar, false);
    this.video.addEventListener('timeupdate', updateLoadBar, false);
    this.video.addEventListener('click', playPause, false);
    this.video.addEventListener('loadedmetadata', setChapterPositions, false);
    this.video.addEventListener('waiting', onWaiting, false);
    this.video.addEventListener('playing', onPlaying, false);
    this.video.addEventListener('pause', onPause, false);
    this.video.addEventListener('mousemove', wakeUp, false);
    this.video.addEventListener('mouseover', wakeUp, false);
    this.video.addEventListener('resize', resize, false);
    this.video.addEventListener('loadeddata', resize, false);
    this.video.addEventListener('loadeddata', function(){this.controlObject.videoLoaded=true;}, false);
    this.video.addEventListener('error', onError, false);
    this.video.style.zIndex=2;
    this.video.style.verticalAlign="middle";
    delete(this.video.controls);
    
    var rs=document.createElement('iframe');
    this.container.appendChild(rs);
    rs.name='measuringTape';
    rs.style.width="100%";
    rs.style.height="0px";
    rs.style.border='none';
    var y = (rs.contentWindow || rs.contentDocument);
    if (y.document)y = y.document;
    y.body.style.backgroundColor = "none transparent";
    y.body.style.margin='0px';
    y.body.style.padding='0px';
    y.body.style.lineHeight='0px';
    y.body.style.fontSize='0px';
    y.body.style.opacity=0;
    rs.style.opacity=0;
    rs.contentWindow.addEventListener('resize', resize, false);
    rs.contentWindow.controlObject=this;
    
    //setting other flags
    if (args.autoplay)
        this.video.autoplay=true;
    if (args.loop)
        this.video.loop=true;
    if (args.preload)
        this.video.preload=args.preload;
    this.video.autobuffer=true;
    delete(this.video.controls);
    if (args.sleepTime>-1)this.sleepTime=args.sleepTime;else this.sleepTime=2000;
    if (args.hideControls)
        this.hideControls=true;
    if (args.stopOnChapters)this.stopOnChapters=args.stopOnChapters;else this.stopOnChapters=false;
    if (args.hideOverPlayButton)this.hideOverPlayButton=args.hideOverPlayButton;else this.hideOverPlayButton=false;
    if (args.logo)this.logo=args.logo;
    if (args.restartChapterKey)this.restartChapterKey=args.restartChapterKey;else this.restartChapterKey=33;
    if (args.nextChapterKey)this.nextChapterKey=args.nextChapterKey;else this.nextChapterKey=34;
    if (args.playPauseKey)this.playPauseKey=args.playPauseKey;else this.playPauseKey=66;
    if (args.volumeUpKey)this.volumeUpKey=args.volumeUpKey;else this.volumeUpKey=38;
    if (args.volumeDownKey)this.volumeDownKey=args.volumeDownKey;else this.volumeDownKey=40;
    if (args.fullScreenKey)this.fullScreenKey=args.fullScreenKey;else this.fullScreenKey=65;
    if (args.disabledKeys)this.disabledKeys=args.disabledKeys;else this.disabledKeys=[116,27];
    if (args.fastForwardRate)this.fastForwardRate=args.fastForwardRate;else this.volumeUpKey=0.05;
    if (args.fastForwardKey)this.fastForwardKey=args.fastForwardKey;else this.fastForwardKey=39;
    if (args.fastRewindKey)this.fastRewindKey=args.fastRewindKey;else this.fastRewindKey=37;
    if ('drawCurrentTimeIndicator' in args)this.drawCurrentTimeIndicator=args.drawCurrentTimeIndicator;else this.drawCurrentTimeIndicator=true;
    if (args.drawRemainingTimeIndicator)this.drawRemainingTimeIndicator=args.drawRemainingTimeIndicator;else this.drawRemainingTimeIndicator=false;
    
    
    this.container.appendChild(this.video);
    this.lastTime=0;
    
    //creating controls
        //over video layer
        var overLayer=document.createElement('div');
        if (!this.hideOverPlayButton)overLayer.className='videoClearOver videoPausedOver';else overLayer.className='videoClearOver';
        overLayer.controlObject=this;
        this.container.appendChild(overLayer);
        overLayer.addEventListener('click', playPause, false);
        overLayer.addEventListener('mousemove', wakeUp, false);
        overLayer.addEventListener('mouseover', wakeUp, false);
        this.overLayer=overLayer;
        //control container
        var nav=document.createElement('nav');
        nav.className='videoPlayerControls';
        nav.controlObject=this;
        this.container.appendChild(nav);
        nav.addEventListener('mousemove', wakeUp, false);
        nav.addEventListener('mouseover', wakeUp, false);
        this.controlContainer=nav;
        if (this.hideControls)nav.style.display='none';
        //play button
        var playButton=document.createElement('div');
        playButton.className='videoPlayerPlay';
        nav.appendChild(playButton);
        playButton.controlObject=this;
        playButton.addEventListener('click', playPause, false);
        playButton.addEventListener('mousemove', wakeUp, false);
        playButton.addEventListener('mouseover', wakeUp, false);
        this.playButton=playButton;
        //fullscreen button
        var fsButton=document.createElement('div');
        fsButton.className='videoPlayerFullScreen';
        nav.appendChild(fsButton);
        fsButton.controlObject=this;
        fsButton.addEventListener('click', fullscreen, false);
        fsButton.addEventListener('mousemove', wakeUp, false);
        fsButton.addEventListener('mouseover', wakeUp, false);
        this.fsButton=fsButton;
        //logo image
        if (this.logo){
            var logoImg=new Image;
            logoImg.controlObject=this;
            logoImg.src=this.logo.src;
            logoImg.addEventListener('error',onLogoError,false);
            logoImg.addEventListener('load',resize,false);
            var logoLink=document.createElement('a');
            logoLink.className='videoPlayerLogo';
            logoLink.style.backgroundImage='url('+this.logo.src+')';
            logoLink.href=this.logo.URL;
            logoLink.target=this.logo.target;
            nav.appendChild(logoLink);
            logoLink.controlObject=this;
            this.logoLink=logoLink;
        }
        //progress container
        var progressContainer=document.createElement('div');
        progressContainer.className='videoProgressContainer';
        nav.appendChild(progressContainer);
        progressContainer.addEventListener('mousemove', wakeUp, false);
        progressContainer.addEventListener('mouseover', wakeUp, false);
        progressContainer.controlObject=this;
        this.progressContainer=progressContainer;
        //progress background
        var progressBackground=document.createElement('div');
        progressBackground.className='videoProgressBackground';
        progressContainer.appendChild(progressBackground);
        progressBackground.addEventListener('mousemove', wakeUp, false);
        progressBackground.addEventListener('mouseover', wakeUp, false);
        progressBackground.controlObject=this;
        this.progressBackground=progressBackground;
        //progress buffer
        var progressBuffer=document.createElement('div');
        progressBuffer.className='videoLoadProgress bar';
        progressContainer.appendChild(progressBuffer);
        this.progressBuffer=progressBuffer;
        //progress bar
        var progressBar=document.createElement('div');
        progressBar.className='videoPlayProgress bar';
        progressContainer.appendChild(progressBar);
        this.progressBar=progressBar;
        progressBar.controlObject=this;
        progressBar.addEventListener('click', changeTimeClick, false);
        progressBar.addEventListener('mousemove', wakeUp, false);
        progressBar.addEventListener('mouseover', wakeUp, false);
        //current time container
        if (this.drawCurrentTimeIndicator) {
            var timeCurrent=document.createElement('div');
            timeCurrent.className='videoPlayCurrentTime';
            progressBar.appendChild(timeCurrent);
            this.timeCurrent=timeCurrent;
            timeCurrent.controlObject=this;
            timeCurrent.addEventListener('click', changeTimeClick, false);
            timeCurrent.addEventListener('mousemove', wakeUp, false);
            timeCurrent.addEventListener('mouseover', wakeUp, false);
        }
        //remaining time container
        if (this.drawRemainingTimeIndicator) {
            var timeRemaining=document.createElement('div');
            timeRemaining.className='videoPlayRemainingTime';
            progressBar.appendChild(timeRemaining);
            this.timeRemaining=timeRemaining;
            timeRemaining.controlObject=this;
            timeRemaining.addEventListener('click', changeTimeClick, false);
            timeRemaining.addEventListener('mousemove', wakeUp, false);
            timeRemaining.addEventListener('mouseover', wakeUp, false);
        }
        
        //volume control
        var volumeButtonD=document.createElement('div');
        volumeButtonD.className='videoPlayerVolume';
        nav.appendChild(volumeButtonD);
        var volumeButtonOver=document.createElement('div');
        volumeButtonOver.className='videoPlayerVolumeOver';
        volumeButtonD.appendChild(volumeButtonOver);
        volumeButtonOver.controlObject=this;
        volumeButtonOver.style.width='100%';
        this.volumeButtonOver=volumeButtonOver;
        
        volumeButton=document.createElement('div');
        volumeButton.className='videoPlayerVolumeOver';
        volumeButton.style.background='none';
        volumeButton.style.backgroundImage='none';
        volumeButton.style.zIndex=12;
        volumeButton.style.cursor='pointer';
        volumeButtonD.appendChild(volumeButton);
        volumeButton.controlObject=this;
        this.volumeButton=volumeButton;
        volumeButton.addEventListener('mousedown', mouseDown, false);
        volumeButton.addEventListener('mouseup', mouseUp, false);
        volumeButton.addEventListener('mouseout', mouseUp, false);
        volumeButton.addEventListener('mousemove', function(args){this.controlObject.volumeChangePress(args);this.controlObject.wakeUp(args);}, false);
        volumeButton.addEventListener('mouseover', wakeUp, false);
        
    //initialization functions
        document.onkeydown=keyPresses;
        document.controlObject=this;
        resize();
    
    //event functions
    
    
    this.onLogoError=onLogoError;function onLogoError(args){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        obj.logo=false;
        obj.controlContainer.removeChild(obj.logoLink);
        obj.resize();
    }
    
    this.onError=onError;function onError(args){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        this.container.style.color='#fff';
        this.container.style.fontSize=20;
        this.container.style.fontFamily='Arial';
        this.container.innerHTML='Error! Something went wrong';
    }
    
    this.wakeUp=wakeUp;function wakeUp(args){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        if (!obj.sleepTime)return;
        if (obj.sleepTimer)clearTimeout(obj.sleepTimer);
        obj.sleepTimer=setTimeout(obj.sleep,obj.sleepTime,obj);
        
        obj.controlContainer.style.animation='fadein ease-in 1';
        obj.controlContainer.style.animationDuration='0.2s';
        obj.controlContainer.style.animationFillMode='forwards';

        obj.controlContainer.style.WebkitAnimation='fadein ease-in 1';
        obj.controlContainer.style.WebkitAnimationDuration='0.2s';
        obj.controlContainer.style.WebkitAnimationFillMode='forwards';

        obj.controlContainer.style.MozAnimation='fadein ease-in 1';
        obj.controlContainer.style.MozAnimationDuration='0.2s';
        obj.controlContainer.style.MozAnimationFillMode='forwards';

        obj.controlContainer.style.MsAnimation='fadein ease-in 1';
        obj.controlContainer.style.MsAnimationDuration='0.2s';
        obj.controlContainer.style.MsAnimationFillMode='forwards';
        
    }
    
    this.sleep=sleep;function sleep(obj){
        if(!obj){if(this.controlObject)obj=this.controlObject;else obj=this;}
        if (!obj.sleepTime)return;
        
        obj.controlContainer.style.animation='fadeout ease-in 1';
        obj.controlContainer.style.animationDuration='0.5s';
        obj.controlContainer.style.animationFillMode='forwards';

        obj.controlContainer.style.WebkitAnimation='fadeout ease-in 1';
        obj.controlContainer.style.WebkitAnimationDuration='0.5s';
        obj.controlContainer.style.WebkitAnimationFillMode='forwards';

        obj.controlContainer.style.MozAnimation='fadeout ease-in 1';
        obj.controlContainer.style.MozAnimationDuration='0.5s';
        obj.controlContainer.style.MozAnimationFillMode='forwards';

        obj.controlContainer.style.MsAnimation='fadeout ease-in 1';
        obj.controlContainer.style.MsAnimationDuration='0.5s';
        obj.controlContainer.style.MsAnimationFillMode='forwards';
        
    }
    this.sleep();
    
    this.resize=resize;function resize(args){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        var e=obj.overLayer;
        if (e) {
            e.style.width=obj.video.clientWidth+'px';
            e.style.height=obj.video.clientHeight+'px';
            e.style.marginTop='-'+obj.video.clientHeight+'px';
        }
        var c=obj.controlContainer;
        if (!c)return;

        if (obj.logo){
            c.style.width=(obj.video.clientWidth-65)+'px';
        }else{
            c.style.width=(obj.video.clientWidth-0)+'px';
        }
        
        var pl=obj.playButton;
        
        var vol=obj.volumeButton;
        
        var fs=obj.fsButton;
        
        var p=obj.progressContainer;
        var w=(obj.video.clientWidth-pl.clientWidth-vol.clientWidth-fs.clientWidth-100);
        if (obj.logo)w-=65;
        var l=parseInt(pl.offsetLeft)+pl.clientWidth+20;
        p.style.width=w+'px';
        p.style.left=l+'px';
        obj.setChapterPositions();
        obj.updateProgressBar();
    }
    
    
    this.onWaiting=onWaiting;function onWaiting(args){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        var e=obj.overLayer;
        e.className='videoClearOver videoLoadingOver';
        e.style.display='block;'
    }
    
    this.onPlaying=onPlaying;function onPlaying(args){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        var e=obj.overLayer;
        e.className='videoClearOver';
        e.style.display='none;'
    }
    
    this.onPause=onPause;function onPause(args){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        var e=obj.overLayer;
        if (!obj.hideOverPlayButton)e.className='videoClearOver videoPausedOver';else e.className='videoClearOver';
        e.style.display='block;'
        obj.pause();
    }
    
    
    this.updateProgressBar=updateProgressBar;function updateProgressBar(args) {
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        var progressBar = obj.video.controlObject.progressBar;
        if (!progressBar)return;
        if(obj.video.currentTime > 30){obj.video.pause(); obj.video.currentTime = 0;}
        var percentage=obj.video.currentTime / obj.video.duration*progressBar.clientWidth;
        progressBar.style.backgroundSize=percentage+"px 100%";
        if (obj.stopOnChapters && !obj.timeskipFW && !obj.timeskipBW)obj.scanChapterChange();
        if (obj.timeskipFW && obj.timeskipFW<=obj.video.currentTime)obj.timeskipFW=false;
        if (obj.timeskipBW && obj.timeskipBW>=obj.video.currentTime)obj.timeskipBW=false;
        obj.lastTime=obj.video.currentTime;
        obj.drawTimer();
    }
    
    this.scanChapterChange=scanChapterChange;function scanChapterChange(){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        if (obj.lastTime>obj.video.currentTime){obj.lastTime=obj.video.currentTime;return;}
        var i;
        for(i=0;i<obj.cues.length;i++){
            if (obj.lastTime<obj.cues[i].startTime && obj.video.currentTime>=obj.cues[i].startTime) {
                obj.pause();
                //obj.video.currentTime=obj.cues[i].startTime;
                break;
            }
        }
        obj.lastTime=obj.video.currentTime;
    }

    this.updateLoadBar=updateLoadBar;function updateLoadBar(args) {
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        if (!obj.video.buffered.length)return;
        var loadBar = obj.video.controlObject.progressBuffer;
        if (!loadBar)return;
        var i,x=0;
        for(i=0;i<obj.video.buffered.length;i++){
            if(obj.video.buffered.end(i)>x)x=obj.video.buffered.end(i);
        }
        if (!loadBar)return;
        var percentage =Math.ceil(100*x /obj.video.duration);
        loadBar.style.backgroundSize=percentage+"% 100%";
    }
    
    document.addEventListener("fullscreenchange", docFullscreenOver);
    document.addEventListener("webkitfullscreenchange", docFullscreenOver);
    document.addEventListener("mozfullscreenchange", docFullscreenOver);
    document.addEventListener("MSFullscreenChange", docFullscreenOver);
    
    this.volumeChangePress=volumeChangePress;function volumeChangePress(args){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        if (!obj.mousePressed)return;
        var volB=obj.volumeButton;
        var volO=obj.volumeButtonOver;
        var maxL=volB.clientWidth;
        var vol=args.offsetX/maxL;
        if (vol<0.1)vol=0;
        if (vol>0.9)vol=1;
        obj.volume(vol);
    }
    
    this.mouseDown=mouseDown;function mouseDown(args){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        obj.mousePressed=true;
        obj.volumeChangePress(args);
    }
    
    this.mouseUp=mouseUp;function mouseUp(args){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        obj.mousePressed=false;
    }

    
    this.changeTimeClick=changeTimeClick;function changeTimeClick(args){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        if(args.target!=obj.progressBar && args.target!=obj.timeCurrent && args.target!=obj.timeRemaining)return;
        x=0;
        if (args.target==obj.timeRemaining)x=obj.progressBar.clientWidth-obj.timeRemaining.clientWidth;
        var percent=(args.offsetX+x)/obj.progressBar.clientWidth;
        obj.setTime(percent*obj.video.duration);
    }

    this.fullscreen=fullscreen;function fullscreen(args){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        if (obj.fullScreen){obj.fullscreenOver();return;}
        var container=obj.container;
        if (
        	document.fullscreenEnabled || 
        	document.webkitFullscreenEnabled || 
        	document.mozFullScreenEnabled ||
            document.msFullscreenEnabled
        )if (container.requestFullscreen) {
        	container.requestFullscreen();
        } else if (container.webkitRequestFullscreen) {
        	container.webkitRequestFullscreen();
        } else if (container.mozRequestFullScreen) {
        	container.mozRequestFullScreen();
        } else if (container.msRequestFullscreen) {
        	container.msRequestFullscreen();
        }
        obj.fullScreen=true;
        document.controlObject=obj;
    }
    
    this.fullscreenOver=fullscreenOver;function fullscreenOver(args){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        if (!obj.fullScreen){return;}
        // exit full-screen
        if (document.exitFullscreen) {
        	document.exitFullscreen();
        } else if (document.webkitExitFullscreen) {
        	document.webkitExitFullscreen();
        } else if (document.mozCancelFullScreen) {
        	document.mozCancelFullScreen();
        } else if (document.msExitFullscreen) {
        	document.msExitFullscreen();
        }
        obj.fullScreen=false;
    }
    
    this.docFullscreenOver=docFullscreenOver;function docFullscreenOver(args){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        if (
        	document.fullscreenElement ||
            document.webkitFullscreenElement ||
            document.mozFullScreenElement ||
            document.msFullscreenElement
        ) {
            obj.fullScreen=true;
        }else obj.fullScreen=false;
        if (obj.fullScreen)obj.fsButton.className="videoPlayerOffFullScreen";else obj.fsButton.className="videoPlayerFullScreen";
    }
    
    this.addChapters=addChapters;function addChapters(cues){
        if (!cues)return;
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        var i,cue;
        if(this.cues)for(i=0;i<this.cues.length;i++){
            obj.progressBar.removeChild(this.cues[i]);
        }
        this.cues=new Array();
        for(i=0;i<cues.length;i++){
            cue=document.createElement('div');
            cue.className='chapterPoint tooltip';
            cue.title=cues[i].text;
            cue.startTime=cues[i].startTime;
            cue.endTime=cues[i].endTime;
            cue.controlObject=obj;
            cue.addEventListener("click", function(){obj.setTime(this.startTime);},false);
            cue.addEventListener('mousemove', wakeUp, false);
            cue.addEventListener('mouseover', wakeUp, false);
            obj.progressBar.appendChild(cue);
            this.cues[this.cues.length]=cue;
        }
        this.setChapterPositions();
        this.chaptersLoaded=true;
    }
    
    this.setChapterPositions=setChapterPositions;function setChapterPositions(){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        if (!obj.video || !obj.video.duration)return;
        obj.drawTimer();
        var i,x;
        var totalSize=obj.progressBar.clientWidth;
        for(i=0;i<obj.cues.length;i++){
            if (obj.cues[i].startTime>obj.video.duration){
                x=0;
                obj.cues[i].style.display='none';
            }else{
                x=Math.floor(parseInt(obj.cues[i].startTime)/parseInt(obj.video.duration)*parseInt(totalSize));
                x-=Math.floor(obj.cues[i].clientWidth/2);
            }
            obj.cues[i].style.left=x+'px';
        }
    }
    
    function getMinSec(time) {
        var min=Math.floor(time/60);
        var sec=Math.floor(time-min*60);
        if (min<9)min='0'+min;
        if (sec<9)sec='0'+sec;
        return(min+':'+sec);
    }

    this.drawTimer=drawTimer;function drawTimer(){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        if(obj.timeCurrent){
            obj.timeCurrent.title=getMinSec(obj.video.currentTime);
            var percentage=obj.video.currentTime /obj.video.duration*obj.progressBar.clientWidth;
            obj.timeCurrent.style.left=percentage+'px';
        }
        if (obj.timeRemaining) {
            obj.timeRemaining.innerHTML=getMinSec(obj.video.duration-obj.video.currentTime);
        }
    }
    
    
    //control functions
    
    this.play=play;function play(){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        obj.playButton.className="videoPlayerPause";
        obj.video.playbackRate=1;
        obj.video.play();
    }

    this.fastForward=fastForward;function fastForward(){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        var x=obj.video.currentTime;
        x+=Math.floor(obj.fastForwardRate*obj.video.duration);
        if (x>obj.video.duration)x=obj.video.duration;
        obj.video.currentTime=x;
    }

    this.fastRewind=fastRewind;function fastRewind(){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        var x=obj.video.currentTime;
        x-=Math.floor(obj.fastForwardRate*obj.video.duration);
        if (x<0)x=0;
        obj.video.currentTime=x;
    }
    
    this.pause=pause;function pause(){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        obj.playButton.className="videoPlayerPlay";
        obj.video.pause();
    }
    
    this.playPause=playPause;function playPause(){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        if(obj.video.paused)
            obj.play();
        else
            obj.pause();
    }
    
    this.volume=volume;function volume(vol){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        var volB=obj.volumeButton;
        var volO=obj.volumeButtonOver;
        var maxL=volB.clientWidth;
        obj.volumeButtonOver.style.width=Math.floor(vol*maxL)+'px';
        obj.video.volume=vol;
    }
    
    this.setTime=setTime;function setTime(time){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;        
        if (!obj || !obj.video || time>obj.video.duration || time<0) {
            console.log('Cannot set duration to '+time);
            return;
        }
        if (time>obj.video.currentTime)obj.timeskipFW=time;
        if (time<obj.video.currentTime)obj.timeskipBW=time;
        obj.video.currentTime=time;
    }
    
    this.getTime=getTime;function getTime(){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        if (!obj || !obj.video)return(-1);
        return(obj.video.currentTime);
    }
    
    this.getChapters=getChapters;function getChapters(){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        if (!obj || !obj.cues || !obj.video)return false;
        var ret=new Array();
        for(i=0;i<obj.cues.length;i++){
            ret[i]={start:obj.cues[i].startTime,end:obj.cues[i].endTime,title:obj.cues[i].title};
        }
        return(ret);
    }
    
    this.getCurrentChapter=getCurrentChapter;function getCurrentChapter(){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        if (!obj || !obj.cues || !obj.video)return false;
        var t=obj.video.currentTime;
        for(i=obj.cues.length-1;i>=0;i--)if(t>=obj.cues[i].startTime && (i==obj.cues.length-1 || t<obj.cues[i+1].startTime) ){
            return(i);
        }
        return(-1);
    }
    
    this.getVideoState=getVideoState;function getVideoState(){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        if (!obj || !obj.video)return false;
        
        if (obj.video.readyState==0)return('not loaded');
        if (obj.video.readyState==1)return('buffering');
        if (obj.video.readyState==2 || obj.video.readyState==3)return('frame loaded');
        if (obj.video.paused)return('paused');
        return('playing');
    }
    
    this.setCurrentChapter=setCurrentChapter;function setCurrentChapter(chapter){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        if (!obj.cues)return;
        if (chapter<0 || chapter>=obj.cues.length)return;
        this.setTime(obj.cues[chapter].startTime);
    }
    
    this.keyPresses=keyPresses;function keyPresses(e){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        var key=e.which || e.keyCode;
        if (key == obj.restartChapterKey){//F5
            e.preventDefault();
            var chapter=obj.getCurrentChapter();
            var ct=obj.video.currentTime;
            obj.setCurrentChapter(chapter);
            if (Math.abs(ct-obj.video.currentTime)<0.1 && chapter>0)obj.setCurrentChapter(chapter-1);
        }
        if (key == obj.nextChapterKey){//.
            e.preventDefault();
            var chapter=obj.getCurrentChapter();
            obj.setCurrentChapter(chapter+1);
        }
        if (key == obj.playPauseKey){//spacebar
            e.preventDefault();
            obj.playPause();
        }
        if (key==obj.volumeUpKey) {
            e.preventDefault();
            var vol=obj.video.volume;vol+=0.1;if (vol>1)vol=1;
            obj.volume(vol);
        }
        if (key==obj.volumeDownKey) {
            e.preventDefault();
            var vol=obj.video.volume;vol-=0.1;if (vol<0)vol=0;
            obj.volume(vol);
        }
        if (key==obj.fullScreenKey) {
            e.preventDefault();
            obj.fullscreen();
        }
        if (key==obj.fastForwardKey) {
            e.preventDefault();
            obj.fastForward();
        }
        if (key==obj.fastRewindKey) {
            e.preventDefault();
            obj.fastRewind();
        }
        if (obj.disabledKeys.indexOf(key)>-1) {
            e.preventDefault();
        }
    }
    
    this.clearVideo=clearVideo;function clearVideo(){
        var obj;if(this.controlObject)obj=this.controlObject;else obj=this;
        obj.container.removeChild(obj.video);
        delete(obj.video);
        //creating the video element
        obj.video = document.createElement('video');
        obj.video.controlObject=this;
        obj.video.style.width="100%";
        obj.video.style.cursor="pointer";
        obj.video.addEventListener('click', playPause, false);
        obj.video.addEventListener('timeupdate', updateProgressBar, false);
        obj.video.addEventListener('progress', updateLoadBar, false);
        obj.video.addEventListener('timeupdate', updateLoadBar, false);
        obj.video.addEventListener('click', playPause, false);
        obj.video.addEventListener('loadedmetadata', setChapterPositions, false);
        obj.video.addEventListener('waiting', onWaiting, false);
        obj.video.addEventListener('playing', onPlaying, false);
        obj.video.addEventListener('pause', onPause, false);
        obj.video.addEventListener('mousemove', wakeUp, false);
        obj.video.addEventListener('mouseover', wakeUp, false);
        obj.video.addEventListener('resize', resize, false);
        obj.video.addEventListener('loadeddata', resize, false);
        obj.video.addEventListener('loadeddata', function(){this.controlObject.videoLoaded=true;}, false);
        obj.video.addEventListener('error', onError, false);
        obj.video.style.zIndex=2;
        obj.video.style.verticalAlign="middle";
        delete(obj.video.controls);
        
        //setting other flags
        if (obj.args.autoplay)obj.video.autoplay=true;
        if (obj.args.loop)obj.video.loop=true;
        if (obj.args.preload)obj.video.preload=args.preload;
        obj.video.autobuffer=true;
        delete(obj.video.controls);
        obj.container.appendChild(obj.video);        
    }
    
    this.load=load;function load(source,tracks,clear){
        this.chaptersLoaded=false;
        this.videoLoaded=false;
        if(clear)this.clearVideo();
        //adding sources
        for(i=0;i<source.length/2;i++){
            var src = document.createElement('source');
            src.src=source[i*2];
            src.type=source[i*2+1];
            this.video.appendChild(src);
        }        
        //adding tracks
        if (tracks)for(i=0;i<tracks.length;i++) {
            var track=document.createElement('track');
            track.kind=tracks[i].kind;
            track.src=tracks[i].src;
            track.type=tracks[i].type;
            track.srclang=tracks[i].srclang;
            track.label=tracks[i].label;
            track.mode='hidden';
            track.hidden=true;
            track.video=this.video;
            if(!i)track.default=true;
            this.video.appendChild(track);
            if (track.kind=='chapters') {
                track.controlObject=this;
                track.addEventListener('load',function(){this.controlObject.addChapters(this.track.cues);this.track.mode='hidden';},false);
            }
        }else this.chaptersLoaded=true;
    }

    //adding sources
    this.load(args.src,args.track,false);

    
}
